/*
 * Generate a VGA signal using a PIC32 microcontroller.
 *
 * Copyright (C) 2017, 2018 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __VGA_COMMON_H__
#define __VGA_COMMON_H__

/* Number of raster scan lines to be used. */

#define SCANLINES               512

/* Horizontal lines, back porch end. */

#define VISIBLE_START           72

/* Horizontal lines, front porch start. */

#define VFP_START               (VISIBLE_START + SCANLINES)

/* Horizontal lines, front porch end. */

#define VSYNC_START             620

/* Horizontal lines, back porch start. */

#define VSYNC_END               622

/* Define DMA channels if not indicated in the build configuration. */

/* CPU-based transfers: no channels. */

#ifdef TRANSFER_CPU
#define LINE_CHANNELS   0

/* DMA-based transfers: single channel by default. */

#else

#ifndef LINE_CHANNELS
#define LINE_CHANNELS   1
#endif

#endif /* TRANSFER_CPU */

#endif /* __VGA_COMMON_H__ */
